/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.core.data;

import fr.cenra.rhomeo.api.data.Reference;
import java.time.ZonedDateTime;
import java.util.Objects;
import javafx.beans.property.BooleanProperty;
import javafx.beans.property.DoubleProperty;
import javafx.beans.property.ObjectProperty;
import javafx.beans.property.SimpleBooleanProperty;
import javafx.beans.property.SimpleDoubleProperty;
import javafx.beans.property.SimpleObjectProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;

/**
 *
 * @author Alexis Manin (Geomatys)
 */
public class MockReference implements Reference {

    public final SimpleStringProperty first = new SimpleStringProperty();
    public final SimpleObjectProperty<ZonedDateTime> second = new SimpleObjectProperty<>();
    public final SimpleDoubleProperty third = new SimpleDoubleProperty();
    public final SimpleBooleanProperty fourth = new SimpleBooleanProperty();

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 89 * hash + Objects.hashCode(this.first.get());
        hash = 89 * hash + Objects.hashCode(this.second.get());
        hash = 89 * hash + Objects.hashCode(this.third.get());
        hash = 89 * hash + Objects.hashCode(this.fourth.get());
        hash = 89 * hash + Objects.hashCode(this.fifth.get());
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MockReference other = (MockReference) obj;
        if (!Objects.equals(this.first.get(), other.first.get()))
            return false;
        if (!(this.second.get() == null)? other.second == null : this.second.get().isEqual(other.second.get()))
            return false;
        if (!Objects.equals(this.third.get(), other.third.get()))
            return false;
        if (!Objects.equals(this.fourth.get(), other.fourth.get()))
            return false;
        if (!Objects.equals(this.fifth.get(), other.fifth.get()))
            return false;
        return true;
    }
    public final SimpleObjectProperty<Float> fifth = new SimpleObjectProperty<>();

    public String getFirst() {
        return first.get();
    }

    public void setFirst(final String newValue) {
        first.set(newValue);
    }

    public StringProperty firstProperty() {
        return first;
    }


    public ZonedDateTime getSecond() {
        return second.get();
    }

    public void setSecond(final ZonedDateTime newValue) {
        second.set(newValue);
    }

    public ObjectProperty<ZonedDateTime> secondProperty() {
        return second;
    }


    public double getThird() {
        return third.get();
    }

    public void setThird(final double newValue) {
        third.set(newValue);
    }

    public DoubleProperty thirdProperty() {
        return third;
    }


    public boolean getFourth() {
        return fourth.get();
    }

    public void setFourth(final boolean newValue) {
        fourth.set(newValue);
    }

    public BooleanProperty fourthProperty() {
        return fourth;
    }

    public Float getFifth() {
        return fifth.get();
    }

    public void setFifth(final Float newValue) {
        fifth.set(newValue);
    }

    public ObjectProperty<Float> fifthProperty() {
        return fifth;
    }
}
